    include "ramdat.asm"
		      dc.l $FFFFFE,   start,     ErrorTrap, ErrorTrap
	          dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
      	      dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
	          dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
	          dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
	          dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
	          dc.l HBlank,    ErrorTrap, VBlank,    ErrorTrap
      	      dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
      	      dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.l ErrorTrap, ErrorTrap, ErrorTrap, ErrorTrap
              dc.b "SEGA MEGASIS    "
              dc.b "(C)  COPYRIGHT  "
              dc.b "Hello world example program for Genesis         "
              dc.b "Hello world example program for Genesis         "
              dc.b "GM 01234567-89"
              dc.w $DEAD        ;checksum
              dc.b "J               "
              dc.l 0
              dc.l ROM_End
              dc.l $FF0000
              dc.l $FFFFFF
              dc.b "    "
              dc.b "    "
              dc.b "    "
              dc.b "            "                           
              dc.b "This program contains blast processing! "
              dc.b "JUE             "
start:                          
        move.b  $A10001,d0
        andi.b  #$0F,d0
        beq no_tmss             ;branch if oldest MD/GEN
        move.l  #'SEGA',$A14000 ;satisfy the TMSS        
no_tmss:
		move.w #$2700, sr       ;disable interrupts
		bsr clear_regs   ;make all registers zero
		bsr clear_ram    ;clear out RAM
        bsr setup_vdp
		bsr clear_vram   ;clear out video memory	
		lea (font),a5    ;ASCII font
		move.w #$07FF,d4 ;Graphics length in words
		move.l #$40000000,(a3);write to VRAM $0000
		bsr vram_loop
		move.l #$c0000000,(a3);write to color memory
		move.w #$0000,(a4) ;black
		move.w #$0000,(a4) ;black
		move.w #$0000,(a4) ;black
		move.w #$0EEE,(a4) ;white		
		bsr display_message
loop:
		bra loop ;wait in a loop doing nothing afterwards.
		
display_message:
		lea (message), a5
		move.l #$671A0000,(a3)  ;write to $271A in VRAM.
message_loop:
		move.b (a5)+,d4	
		cmpi.b #$24,d4			;$ (end of text flag)
		beq return
		andi.w #$00ff,d4
        move.w d4,(a4)		
		bra message_loop

return:
		rts
	
;set-up stuff below this line	
;-----------------------------------------------------	

setup_vdp:
        lea    $C00004.l,a3     ;VDP control port
	    lea    $C00000.l,a4     ;VDP data port
        lea    (VDPSetupArray).l,a5
        move.w #0018,d4         ;loop counter
VDP_Loop:
        move.w (a5)+,(a3)       ;load setup array
	    nop
        dbf d4,VDP_Loop
        rts  
		
vram_Loop:
        move.w (a5)+,(a4)
        dbf d4,vram_Loop
        rts  
		
clear_regs:
		moveq #$00000000,d0
		moveq #$00000000,d1
		moveq #$00000000,d2
		moveq #$00000000,d3
		moveq #$00000000,d4
		moveq #$00000000,d5
		moveq #$00000000,d6
		moveq #$00000000,d7
		move.l d0,a0
		move.l d0,a1
		move.l d0,a2
		move.l d0,a3
		move.l d0,a4
		move.l d0,a5
		move.l d0,a6
		rts
		
clear_ram:
		move.w #$7FF0,d0
		move.l #$FF0000,a0	
clear_ram_loop:
		move.w #$0000,(a0)+
		dbf d0, clear_ram_loop
		rts
		
clear_vram:
		move.l #$40000000,(a3)
		move.w #$7fff,d4
vram_clear_loop:
		move.w #$0000,(a4)
		dbf d4, vram_clear_loop
		rts
	
ErrorTrap:        
        bra ErrorTrap

HBlank:
        rte

VBlank:
        rte
		
message:
 dc.b "Hello world!$ " ;$ for end of line flag, extra space to align evenly.
		
font:
	incbin "ascii.bin"		
	
VDPSetupArray:
	dc.w $8014		
	dc.w $8164  ;Genesis mode, DMA disabled, VBLANK-INT enabled		
	dc.w $8208	;field A at $2000    
	dc.w $8300
	dc.w $8401	;field B at $2000	
	dc.w $8518	;sprite
	dc.w $8600
	dc.w $8700  ;BG color		
	dc.w $8800
	dc.w $8900
	dc.w $8AFF	;no H-int
	dc.w $8B00		
	dc.w $8C81	
	dc.w $8D34		
	dc.w $8E00
	dc.w $8F02	;auto increment	(should almost always be 2)
	dc.w $9001		
	dc.w $9100		
	dc.w $9200

ROM_End:
              
              